Index: /code/branches/Presentation_FS19/src/modules/pacman/PacmanGhost.h
===================================================================
--- /code/branches/Presentation_FS19/src/modules/pacman/PacmanGhost.h	(revision 12407)
+++ /code/branches/Presentation_FS19/src/modules/pacman/PacmanGhost.h	(revision 12408)
@@ -36,5 +36,15 @@
 #include "worldentities/ControllableEntity.h"
 
+#include "Pacman.h"
+
 namespace orxonox {
+
+    extern Vector3 possibleposition[67];
+
+    extern bool findpos(Vector3 one, Vector3 other);
+
+
+
+
 
     class _OrxonoxExport PacmanGhost : public ControllableEntity
@@ -44,19 +54,18 @@
             virtual ~PacmanGhost();
 
-            virtual void XMLPort(Element& xmlelement, XMLPort::Mode mode); //!< Method for creating an AutonomousDrone through XML.
-            virtual void tick(float dt); //!< Defines which actions the AutonomousDrone has to take in each tick.
+            virtual void XMLPort(Element& xmlelement, XMLPort::Mode mode) ; //!< Method for creating an AutonomousDrone through XML.
+            //virtual void tick(float dt); //!< Defines which actions the AutonomousDrone has to take in each tick.
 
-            void move(float dt, Vector3 actuelposition, Vector3 velocity);
+            virtual void move(float dt, Vector3 actuelposition, Vector3 velocity);
             
-            void resetGhost();
+            virtual void resetGhost();
 
-            void changewith(PacmanGhost* otherghost);
-            void levelupvelo();
-
-            bool findpos(Vector3 one, Vector3 other);      
-            void changemovability();
+            virtual void changewith(PacmanGhost* otherghost);
+            virtual void levelupvelo();
+      
+            virtual void changemovability();
             bool dontmove = false;
 
-        private:
+       
             int decision = 0; 
             Vector3 resetposition = Vector3(0,10,15);
@@ -70,8 +79,47 @@
             bool lockmove = false;
 
-            void setnewTarget(int firstdec);
-            void setnewTarget(int firstdec, int seconddec);
-            void setnewTarget(int firstdec, int seconddec, int thirddec);
-            void setnewTarget(int firstdec, int seconddec, int thirddec, int fourthdec);
+
+        Vector3 getPlayerPos();
+
+        Vector3 playerPos;
+
+        Vector3 lastPlayerPassedPoint;
+
+        Vector3 pointInFrontOfPlayer;
+        
+        /*
+    public: //HACK
+    */
+
+
+    struct graphVertex;
+    void findNeighboorVertices(Vector3 actuelposition, graphVertex* adjacentVertices[], graphVertex listOfVerticesP2[]);
+    void updateShortestDistanceToStart(graphVertex &vertex, graphVertex &neighboor);
+    void findNearestNonVisitedNeighboor (graphVertex &vertex, Vector3 pointToAvoidP3=Vector3(0,0,0));
+    int graphDistance(Vector3 start, Vector3 goal);
+
+    graphVertex* findNextVertexToConsider(graphVertex listOfVerticesP[], Vector3 pointToAvoidP2=Vector3(0,0,0));
+    Vector3 getShortestPath(Vector3 start, Vector3 goal, Vector3 pointToAvoidP1=Vector3(0,0,0));
+
+
+
+    Vector3 getPointInFrontOfPacman(Vector3 pacLasVisPos,int indexForSWNE);
+    int findPlayerTravDir (Vector3 playerPosBefore, Vector3 playerPos);
+    Vector3 diffVector (Vector3 start, Vector3 goal);
+
+    bool playerFindPos(Vector3 one, Vector3 other);
+
+    bool jeanfindpos(Vector3 one, Vector3 other);
+
+    void setNewTargetGhost(Vector3 goalToGo);
+
+
+
+
+
+    void findNeighboorPositions(Vector3 actuelposition, Vector3 adjacentPositions[], Vector3 positionArray[]);
+
+    Vector3 frontPosition();
+
     };
 
Index: /code/branches/Presentation_FS19/src/modules/pacman/PacmanLaser.cpp
===================================================================
--- /code/branches/Presentation_FS19/src/modules/pacman/PacmanLaser.cpp	(revision 12408)
+++ /code/branches/Presentation_FS19/src/modules/pacman/PacmanLaser.cpp	(revision 12408)
@@ -0,0 +1,51 @@
+#include "PacmanLaser.h"
+
+#include "core/CoreIncludes.h"
+#include "BulletDynamics/Dynamics/btRigidBody.h"
+
+namespace orxonox
+{
+    RegisterClass(PacmanLaser);
+
+    /**
+    @brief
+        Constructor. Registers the object and initializes some default values.
+    @param creator
+        The creator of this object.
+    */
+    PacmanLaser::PacmanLaser(Context* context) : ControllableEntity(context)
+    {
+        RegisterObject(PacmanLaser);
+        this->setCollisionType(CollisionType::None);
+    }
+
+    /**
+    @brief
+        Destructor. Destroys controller, if present.
+    */
+    PacmanLaser::~PacmanLaser()
+    {
+        // Deletes the controller if the object was initialized and the pointer to the controller is not NULL.
+    }
+
+    /**
+    @brief
+        Method for creating a AutonomousDrone through XML.
+    */
+    void PacmanLaser::XMLPort(Element& xmlelement, XMLPort::Mode mode)
+    {
+        SUPER(PacmanLaser, XMLPort, xmlelement, mode);
+    }
+
+
+    void PacmanLaser::tick(float dt)
+    {
+        SUPER(PacmanLaser, tick, dt);
+    }
+
+    void PacmanLaser::resetPacmanLaser(){
+    	resetposition = this->getPosition();
+        resetposition.y = -20000;
+        this->setPosition(resetposition);
+    }
+}
Index: /code/branches/Presentation_FS19/src/modules/pacman/PacmanLaser.h
===================================================================
--- /code/branches/Presentation_FS19/src/modules/pacman/PacmanLaser.h	(revision 12408)
+++ /code/branches/Presentation_FS19/src/modules/pacman/PacmanLaser.h	(revision 12408)
@@ -0,0 +1,31 @@
+#ifndef _PacmanLaser_H__
+#define _PacmanLaser_H__
+
+#include "OrxonoxPrereqs.h"
+
+#include "core/XMLPort.h"
+
+#include "worldentities/ControllableEntity.h"
+
+namespace orxonox {
+
+    class _OrxonoxExport PacmanLaser : public ControllableEntity
+    {
+        public:
+            PacmanLaser(Context* context);
+            virtual ~PacmanLaser();
+
+            virtual void XMLPort(Element& xmlelement, XMLPort::Mode mode); //!< Method for creating an AutonomousDrone through XML.
+            virtual void tick(float dt); //!< Defines which actions the AutonomousDrone has to take in each tick.
+            void resetPacmanLaser();
+            
+
+        private:
+            
+            Vector3 resetposition;
+    
+    };
+
+}
+
+#endif
Index: /code/branches/Presentation_FS19/src/modules/pacman/PacmanPink.cc
===================================================================
--- /code/branches/Presentation_FS19/src/modules/pacman/PacmanPink.cc	(revision 12408)
+++ /code/branches/Presentation_FS19/src/modules/pacman/PacmanPink.cc	(revision 12408)
@@ -0,0 +1,112 @@
+	
+#include "PacmanPink.h"
+
+#include "core/CoreIncludes.h"
+#include "BulletDynamics/Dynamics/btRigidBody.h"
+
+	
+namespace orxonox{
+
+	RegisterClass(PacmanPink);
+
+		PacmanPink::PacmanPink(Context* context) : PacmanGhost(context){
+
+        RegisterObject(PacmanPink);
+
+        this->target_x=0;
+        this->target_z=15;
+        this->lastPlayerPassedPoint=Vector3(0,0,0); 
+        this->pointInFrontOfPlayer=Vector3(0,0,0);
+          
+    }
+
+    /**
+    @brief
+        Method for creating a ghost through XML.
+    */
+    void PacmanPink::XMLPort(Element& xmlelement, XMLPort::Mode mode)
+    {
+        SUPER(PacmanPink, XMLPort, xmlelement, mode);
+    }
+
+
+    void PacmanPink::tick(float dt)
+    {
+        SUPER(PacmanGhost, tick, dt);
+        this->actuelposition = this->getPosition();
+
+        for(int u=0; u < 67; u++){//always check if player passed a point
+            if(jeanfindpos(this->getPlayerPos(), possibleposition[u])){ 
+                    this->lastPlayerPassedPoint=possibleposition[u];        
+                }
+            }
+
+        this->pointInFrontOfPlayer=frontPosition(); 
+        Vector3 pinkPos=Vector3(this->target_x, 10, this->target_z);
+        
+        //Stop, if target arrived
+        if((abs(this->actuelposition.x - this->target_x)<0.5) && (abs(this->actuelposition.z - this->target_z)<0.5)){
+                 this->ismoving = false;
+        }
+
+        //Move, if ghost hasn't arrived yet
+        if(this->ismoving){
+            if(!(abs(this->actuelposition.z-target_z)<0.5)) {
+                velocity = Vector3(0,0,-sgn(this->actuelposition.z-this->target_z));
+                move(dt, actuelposition, velocity);
+            }    
+            if(!(abs(this->actuelposition.x-target_x)<0.5)){
+                velocity = Vector3(-sgn(this->actuelposition.x-this->target_x),0,0);
+                move(dt, actuelposition, velocity);
+            }
+        }
+        else if(this->lastPlayerPassedPoint==Vector3(0,0,0)){
+            //as long as the player has not started the game,
+            //i.e. lastPlayerPastPoint is (0,0,0), pink pacman
+            //cannot possibly move, because it needs the position
+            //of the player to move accordingly
+
+            this->ismoving=false;
+        }
+        else if(this->pointInFrontOfPlayer==Vector3(0,0,0)){
+
+            Vector3 pinkPos=Vector3(this->target_x, 10, this->target_z);
+            setNewTargetGhost(getShortestPath(pinkPos, this->lastPlayerPassedPoint));
+
+        }
+        //Check on which position the ghost has arrived and set new target
+         else{
+            while(lockmove){};
+            lockmove = true;
+            nextMove(pinkPos, pointInFrontOfPlayer, lastPlayerPassedPoint);
+            lockmove=false;
+        }
+	}
+
+
+
+    void PacmanPink::nextMove( Vector3 pinkPosP, Vector3 playerPos, Vector3 pointToAvoidP11){
+    
+        Vector3 nextTarget;
+
+        if(playerPos==pointToAvoidP11){ //SIGSEV if playerPos==pointToAvoidP11 otherwise
+            nextTarget = getShortestPath(pinkPosP, playerPos);
+        }
+        else if(playerPos==Vector3(-70,10,-35)){
+            
+        nextTarget=getShortestPath(pinkPosP, Vector3(-70,10,-35));
+        
+        }
+        else{   
+        
+        nextTarget = getShortestPath(pinkPosP, playerPos, pointToAvoidP11);
+        }
+        
+       setNewTargetGhost(nextTarget);
+    }
+
+}
+
+	
+
+	
Index: /code/branches/Presentation_FS19/src/modules/pacman/PacmanPink.h
===================================================================
--- /code/branches/Presentation_FS19/src/modules/pacman/PacmanPink.h	(revision 12408)
+++ /code/branches/Presentation_FS19/src/modules/pacman/PacmanPink.h	(revision 12408)
@@ -0,0 +1,27 @@
+#ifndef _PacmanPink_H__
+#define _PacmanPink_H__
+
+
+#include "PacmanGhost.h"
+
+
+namespace orxonox {
+
+	class _OrxonoxExport PacmanPink : public PacmanGhost{
+
+		public :
+			PacmanPink(Context* context);
+
+			virtual void tick(float dt) override; //!< Defines which actions the AutonomousDrone has to take in each tick.
+
+  			virtual void XMLPort(Element& xmlelement, XMLPort::Mode mode) override;
+
+        Vector3 pinkPos;
+
+        void nextMove(Vector3 pinkPosP, Vector3 playerPos, Vector3 pointToAvoidP11=Vector3(0,0,0));
+
+	};
+
+}
+
+#endif 
Index: /code/branches/Presentation_FS19/src/modules/pacman/PacmanRandom.cc
===================================================================
--- /code/branches/Presentation_FS19/src/modules/pacman/PacmanRandom.cc	(revision 12408)
+++ /code/branches/Presentation_FS19/src/modules/pacman/PacmanRandom.cc	(revision 12408)
@@ -0,0 +1,353 @@
+#include "PacmanRandom.h"
+
+#include "core/CoreIncludes.h"
+#include "BulletDynamics/Dynamics/btRigidBody.h"
+
+
+
+
+namespace orxonox {
+
+
+    RegisterClass(PacmanRandom);
+
+
+
+    PacmanRandom::PacmanRandom(Context* context) : PacmanGhost(context){
+
+        RegisterObject(PacmanRandom);
+        
+        
+    }
+
+        /**
+    @brief
+        Method for creating a ghost through XML.
+    */
+    void PacmanRandom::XMLPort(Element& xmlelement, XMLPort::Mode mode)
+    {
+        SUPER(PacmanRandom, XMLPort, xmlelement, mode);
+    }
+
+    void PacmanRandom::tick(float dt)
+    {
+        SUPER(PacmanGhost, tick, dt);
+
+        this->actuelposition = this->getPosition();
+        
+        //Stop, if target arrived
+        if((abs(this->actuelposition.x - this->target_x)<0.5) && (abs(this->actuelposition.z - this->target_z)<0.5)){
+                 this->ismoving = false;
+        }
+
+        //Move, if ghost hasn't arrived yet
+        if(this->ismoving){
+            if(!(abs(this->actuelposition.z-target_z)<0.5)) {
+                velocity = Vector3(0,0,-sgn(this->actuelposition.z-this->target_z));
+                move(dt, actuelposition, velocity);
+            }    
+            if(!(abs(this->actuelposition.x-target_x)<0.5)){
+                velocity = Vector3(-sgn(this->actuelposition.x-this->target_x),0,0);
+                move(dt, actuelposition, velocity);
+            }
+        }
+        //Check on which position the ghost has arrived and set new target
+         else{
+            while(lockmove){};
+            lockmove = true;
+
+            if(findpos(actuelposition,possibleposition[0])){
+                setnewTarget(1,17,19);
+            }
+            else if(findpos(actuelposition,possibleposition[1])){
+                setnewTarget(0,2);
+            }
+            else if(findpos(actuelposition,possibleposition[2])){
+                setnewTarget(1,3);
+            }
+            else if(findpos(actuelposition,possibleposition[3])){
+                setnewTarget(2,4,5);
+            }
+            else if(findpos(actuelposition,possibleposition[4])){
+                setnewTarget(3,6);
+            }
+            else if(findpos(actuelposition,possibleposition[5])){
+                setnewTarget(3,7);
+            }
+            else if(findpos(actuelposition,possibleposition[6])){
+                setnewTarget(4,9,26);
+            }
+            else if(findpos(actuelposition,possibleposition[7])){
+                setnewTarget(5,8);
+            }
+            else if(findpos(actuelposition,possibleposition[8])){
+                setnewTarget(7,9);
+            }
+            else if(findpos(actuelposition,possibleposition[9])){
+                setnewTarget(6,8,10,38);
+            }
+            else if(findpos(actuelposition,possibleposition[10])){
+                setnewTarget(9,11,45);
+            }
+            else if(findpos(actuelposition,possibleposition[11])){
+                setnewTarget(10,12,13);
+            }
+            else if(findpos(actuelposition,possibleposition[12])){
+                setnewTarget(11,14);
+            }
+            else if(findpos(actuelposition,possibleposition[13])){
+                setnewTarget(11,14,16,61);
+            }
+            else if(findpos(actuelposition,possibleposition[14])){
+                setnewTarget(12,13,15);
+            }
+            else if(findpos(actuelposition,possibleposition[15])){
+                setnewTarget(14,16);
+            }
+            else if(findpos(actuelposition,possibleposition[16])){
+                setnewTarget(13,15,62);
+            }
+            else if(findpos(actuelposition,possibleposition[17])){
+                setnewTarget(0,25);
+            }
+            else if(findpos(actuelposition,possibleposition[18])){
+                setnewTarget(19,24);
+            }
+            else if(findpos(actuelposition,possibleposition[19])){
+                setnewTarget(0,18,20);
+            }
+            else if(findpos(actuelposition,possibleposition[20])){
+                setnewTarget(19,21);
+            }
+            else if(findpos(actuelposition,possibleposition[21])){
+                setnewTarget(20,22);
+            }
+            else if(findpos(actuelposition,possibleposition[22])){
+                setnewTarget(21,23,31);
+            }
+            else if(findpos(actuelposition,possibleposition[23])){
+                setnewTarget(22,30);
+            }
+            else if(findpos(actuelposition,possibleposition[24])){
+                setnewTarget(18,29);
+            }
+            else if(findpos(actuelposition,possibleposition[25])){
+                setnewTarget(17,26);
+            }
+            else if(findpos(actuelposition,possibleposition[26])){
+                setnewTarget(6,25,27);
+            }
+            else if(findpos(actuelposition,possibleposition[27])){
+                setnewTarget(26,28,37);
+            }
+            else if(findpos(actuelposition,possibleposition[28])){
+                setnewTarget(27,29,36);
+            }
+            else if(findpos(actuelposition,possibleposition[29])){
+                setnewTarget(24,28,30);
+            }
+            else if(findpos(actuelposition,possibleposition[30])){
+                setnewTarget(23,29,34);
+            }
+            else if(findpos(actuelposition,possibleposition[31])){
+                setnewTarget(22,32);
+            }
+            else if(findpos(actuelposition,possibleposition[32])){
+                setnewTarget(31,33);
+            }
+            else if(findpos(actuelposition,possibleposition[33])){
+                setnewTarget(32,34);
+            }
+            else if(findpos(actuelposition,possibleposition[34])){
+                setnewTarget(30,33,35,42);
+            }
+            else if(findpos(actuelposition,possibleposition[35])){
+                setnewTarget(34,36,41);
+            }
+            else if(findpos(actuelposition,possibleposition[36])){
+                setnewTarget(28,35);
+            }
+            else if(findpos(actuelposition,possibleposition[37])){
+                setnewTarget(27,38);
+            }
+            else if(findpos(actuelposition,possibleposition[38])){
+                setnewTarget(9,37,39);
+            }
+            else if(findpos(actuelposition,possibleposition[39])){
+                setnewTarget(38,40,45);
+            }
+            else if(findpos(actuelposition,possibleposition[40])){
+                setnewTarget(39,41); //Shouldn't be able to return in center
+            }
+            else if(findpos(actuelposition,possibleposition[41])){
+                setnewTarget(35,43);
+            }
+            else if(findpos(actuelposition,possibleposition[42])){
+                setnewTarget(34,43,54);
+            }
+            else if(findpos(actuelposition,possibleposition[43])){
+                setnewTarget(41,46);
+            }
+            else if(findpos(actuelposition,possibleposition[44])){
+                setnewTarget(40,66);
+            }
+            else if(findpos(actuelposition,possibleposition[45])){
+                setnewTarget(10,39,49);
+            }
+            else if(findpos(actuelposition,possibleposition[46])){
+                setnewTarget(43,47);
+            }
+            else if(findpos(actuelposition,possibleposition[47])){
+                setnewTarget(46,52,66);
+            }
+            else if(findpos(actuelposition,possibleposition[48])){
+                setnewTarget(49,51,66);
+            }
+            else if(findpos(actuelposition,possibleposition[49])){
+                setnewTarget(45,48);
+            }
+            else if(findpos(actuelposition,possibleposition[50])){
+                setnewTarget(51,61);
+            }
+            else if(findpos(actuelposition,possibleposition[51])){
+                setnewTarget(48,50);
+            }
+            else if(findpos(actuelposition,possibleposition[52])){
+                setnewTarget(47,53);
+            }
+            else if(findpos(actuelposition,possibleposition[53])){
+                setnewTarget(52,58);
+            }
+            else if(findpos(actuelposition,possibleposition[54])){
+                setnewTarget(42,55,57);
+            }
+            else if(findpos(actuelposition,possibleposition[55])){
+                setnewTarget(54,56);
+            }
+            else if(findpos(actuelposition,possibleposition[56])){
+                setnewTarget(55,57,65);
+            }
+            else if(findpos(actuelposition,possibleposition[57])){
+                setnewTarget(54,56,58,64);
+            }
+            else if(findpos(actuelposition,possibleposition[58])){
+                setnewTarget(53,57,59);
+            }
+            else if(findpos(actuelposition,possibleposition[59])){
+                setnewTarget(58,59,63);
+            }
+            else if(findpos(actuelposition,possibleposition[60])){
+                setnewTarget(59,61,62);
+            }
+            else if(findpos(actuelposition,possibleposition[61])){
+                setnewTarget(13,50,60);
+            }
+            else if(findpos(actuelposition,possibleposition[62])){
+                setnewTarget(16,60);
+            }
+            else if(findpos(actuelposition,possibleposition[63])){
+                setnewTarget(59,64);
+            }
+            else if(findpos(actuelposition,possibleposition[64])){
+                setnewTarget(57,63,65);
+            }
+            else if(findpos(actuelposition,possibleposition[65])){
+                setnewTarget(56,64);
+            }
+            else if(findpos(actuelposition,possibleposition[66])){
+                setnewTarget(47,48);
+            }
+
+            else{
+                this->resetGhost(); //Shouldn't happen...
+            } //End of Position table
+                lockmove = false;  //never forget this one !!!!
+            }
+        
+    }
+
+    void PacmanRandom::setnewTarget(int firstdec){
+        
+          decision = rand()%1;
+            switch(decision){
+                case 0:
+                    this->target_x = possibleposition[firstdec].x;
+                    this->target_z = possibleposition[firstdec].z; 
+                    this->ismoving = true;
+                    break;
+            }
+    }
+
+    //Random choice of new target
+    void PacmanRandom::setnewTarget(int firstdec, int seconddec){ 
+           decision = rand()%2;
+            switch(decision){
+                case 0:
+                    this->target_x = possibleposition[firstdec].x;
+                    this->target_z = possibleposition[firstdec].z; 
+                    this->ismoving = true;
+                    break;
+                case 1:
+                    this->target_x = possibleposition[seconddec].x;
+                    this->target_z = possibleposition[seconddec].z; 
+                    this->ismoving = true;
+                    break;  
+            }
+            
+    }
+
+    //Random choice of new target
+    void PacmanRandom::setnewTarget(int firstdec, int seconddec, int thirddec){
+        
+           decision = rand()%3;
+            switch(decision){
+                case 0:
+                    this->target_x = possibleposition[firstdec].x;
+                    this->target_z = possibleposition[firstdec].z; 
+                    this->ismoving = true;
+                    break;
+                case 1:
+                    this->target_x = possibleposition[seconddec].x;
+                    this->target_z = possibleposition[seconddec].z; 
+                    this->ismoving = true;
+                    break;
+                case 2:
+                    this->target_x = possibleposition[thirddec].x;
+                    this->target_z = possibleposition[thirddec].z; 
+                    this->ismoving = true;
+                    break;    
+            }
+            
+    }
+
+    //Random choice of new target
+    void PacmanRandom::setnewTarget(int firstdec, int seconddec, int thirddec, int fourthdec){
+        
+           decision = rand()%4;
+            switch(decision){
+                case 0:
+                    this->target_x = possibleposition[firstdec].x;
+                    this->target_z = possibleposition[firstdec].z; 
+                    this->ismoving = true;
+                    break;
+                case 1:
+                    this->target_x = possibleposition[seconddec].x;
+                    this->target_z = possibleposition[seconddec].z; 
+                    this->ismoving = true;
+                    break;
+                case 2:
+                    this->target_x = possibleposition[thirddec].x;
+                    this->target_z = possibleposition[thirddec].z; 
+                    this->ismoving = true;
+                    break;
+                case 3:
+                    this->target_x = possibleposition[fourthdec].x;
+                    this->target_z = possibleposition[fourthdec].z; 
+                    this->ismoving = true;
+                    break;    
+            }
+            
+    }
+
+
+}
Index: /code/branches/Presentation_FS19/src/modules/pacman/PacmanRandom.h
===================================================================
--- /code/branches/Presentation_FS19/src/modules/pacman/PacmanRandom.h	(revision 12408)
+++ /code/branches/Presentation_FS19/src/modules/pacman/PacmanRandom.h	(revision 12408)
@@ -0,0 +1,28 @@
+#ifndef _PacmanRandom_H__
+#define _PacmanRandom_H__
+
+#include "PacmanGhost.h"
+
+namespace orxonox {
+
+  class _OrxonoxExport PacmanRandom : public PacmanGhost{
+    //This class is not used anymore in the game, given that all 4 Ghosts now have
+    //their own behavior. But it could maybe still be useful.
+
+  		public:
+  			PacmanRandom(Context* context);
+
+  			virtual void tick(float dt) override; //!< Defines which actions the AutonomousDrone has to take in each tick.
+
+  			virtual void XMLPort(Element& xmlelement, XMLPort::Mode mode) override;
+  			void setnewTarget(int firstdec);
+            void setnewTarget(int firstdec, int seconddec);
+            void setnewTarget(int firstdec, int seconddec, int thirddec);
+            void setnewTarget(int firstdec, int seconddec, int thirddec, int fourthdec);
+  };
+
+
+}
+
+
+#endif 
Index: /code/branches/Presentation_FS19/src/modules/pacman/PacmanRed.cc
===================================================================
--- /code/branches/Presentation_FS19/src/modules/pacman/PacmanRed.cc	(revision 12408)
+++ /code/branches/Presentation_FS19/src/modules/pacman/PacmanRed.cc	(revision 12408)
@@ -0,0 +1,111 @@
+#include "PacmanRed.h"
+
+#include "core/CoreIncludes.h"
+#include "BulletDynamics/Dynamics/btRigidBody.h"
+
+
+
+	namespace orxonox{
+
+		RegisterClass(PacmanRed);
+
+		PacmanRed::PacmanRed(Context* context) : PacmanGhost(context){
+
+        RegisterObject(PacmanRed);
+        this->target_x=0;
+        this->target_z=15;
+        this->lastPlayerPassedPoint=Vector3(0,0,0); 
+        this->isNearPlayer=false;
+          
+    }
+
+
+    /**
+    @brief
+        Method for creating a ghost through XML.
+    */
+    void PacmanRed::XMLPort(Element& xmlelement, XMLPort::Mode mode)
+    {
+        SUPER(PacmanRed, XMLPort, xmlelement, mode);
+    }
+
+    void PacmanRed::tick(float dt)
+    {
+        SUPER(PacmanGhost, tick, dt);
+
+        this->actuelposition = this->getPosition();
+
+        for(int u=0; u < 67; u++){//always check if player passed a point
+            
+                if(jeanfindpos(this->getPlayerPos(), possibleposition[u])){
+                    
+                this->lastPlayerPassedPoint=possibleposition[u];
+                            }    
+            }
+
+        //Stop, if target arrived
+        if((abs(this->actuelposition.x - this->target_x)<0.5) && (abs(this->actuelposition.z - this->target_z)<0.5)){
+            
+                 this->ismoving = false;
+        }
+
+        //Move, if ghost hasn't arrived yet
+        if(this->ismoving){
+            
+            if(!(abs(this->actuelposition.z-target_z)<0.5)) {
+                velocity = Vector3(0,0,-sgn(this->actuelposition.z-this->target_z));
+                move(dt, actuelposition, velocity);
+            }    
+            if(!(abs(this->actuelposition.x-target_x)<0.5)){
+                velocity = Vector3(-sgn(this->actuelposition.x-this->target_x),0,0);
+                move(dt, actuelposition, velocity);
+            }
+        
+        }
+        else if(this->lastPlayerPassedPoint==Vector3(0,0,0)){
+            //as long as the player has not started the game,
+            //i.e. lastPlayerPastPoint is (0,0,0), red pacman
+            //cannot possibly move, because it needs the position
+            //of the player to move accordingly
+
+            this->ismoving=false;
+        }
+
+        //Check on which position the ghost has arrived and set new target
+        else{
+
+            while(lockmove){};
+            lockmove = true;
+
+        	//do red behavior
+            //Use target_x and target_z for position of red pacman
+
+            Vector3 redPos=Vector3(this->target_x, 10, this->target_z);
+            this->pointInFrontOfPlayer=frontPosition(); 
+
+            if(!findpos(this->actuelposition, lastPlayerPassedPoint)){
+                
+            nextMove(redPos, lastPlayerPassedPoint);
+            }
+            else if(findpos(this->actuelposition, lastPlayerPassedPoint)){// red pacman is at lastPlayerPassedPoint
+
+            nextMove(lastPlayerPassedPoint, pointInFrontOfPlayer); 
+            }
+
+            lockmove=false; //NEVER FORGET THIS ONE !!!!!!!
+        }
+        
+    }
+
+
+	void PacmanRed::nextMove( Vector3 redPosP, Vector3 playerPos){
+	
+        Vector3 nextTarget;
+
+        if(redPosP!=playerPos){
+	   nextTarget = getShortestPath(redPosP, playerPos);
+       setNewTargetGhost(nextTarget);
+        }
+	}
+
+}
Index: /code/branches/Presentation_FS19/src/modules/pacman/PacmanRed.h
===================================================================
--- /code/branches/Presentation_FS19/src/modules/pacman/PacmanRed.h	(revision 12408)
+++ /code/branches/Presentation_FS19/src/modules/pacman/PacmanRed.h	(revision 12408)
@@ -0,0 +1,31 @@
+#ifndef _PacmanRed_H__
+#define _PacmanRed_H__
+
+
+#include "PacmanGhost.h"
+
+
+namespace orxonox {
+
+	class _OrxonoxExport PacmanRed : public PacmanGhost{
+
+		public :
+			PacmanRed(Context* context);
+
+			virtual void tick(float dt) override; //!< Defines which actions the AutonomousDrone has to take in each tick.
+
+  			virtual void XMLPort(Element& xmlelement, XMLPort::Mode mode) override;
+
+  			void nextMove(Vector3 playerPos, Vector3 redPos);
+
+  			void mainBehaviourRed();
+
+  			bool isNearPlayer;
+
+
+
+	};
+
+}
+
+#endif 
